/*
 * Copyright (C) 2016 Canon Inc.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted, provided that the following conditions
 * are required to be met:
 *
 * 1.  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 * 2.  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 * 3.  Neither the name of Canon Inc. nor the names of
 *     its contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY CANON INC. AND ITS CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL CANON INC. AND ITS CONTRIBUTORS BE LIABLE FOR
 * ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */


#ifndef ReadableStreamSource_h
#define ReadableStreamSource_h

#if ENABLE(STREAMS_API)

#include "JSDOMPromise.h"
#include "ReadableStreamDefaultController.h"
#include <runtime/ArrayBuffer.h>
#include <wtf/Optional.h>
#include <wtf/PassOwnPtr.h>

namespace WebCore {

typedef int ExceptionCode;

class ReadableStreamSource : public RefCounted<ReadableStreamSource> {
public:
    virtual ~ReadableStreamSource() { }

    void start(PassOwnPtr<ReadableStreamDefaultController>, RefPtr<DeferredPromise>);
    void pull(RefPtr<DeferredPromise>);
    void cancel(const ScriptValue&);

    bool isPulling() const { return !!m_promise; }

protected:
    ReadableStreamDefaultController& controller() { return *m_controller; }
    const ReadableStreamDefaultController& controller() const { return *m_controller; }

    void startFinished();
    void pullFinished();
    void cancelFinished();
    void clean();

    virtual void setActive() = 0;
    virtual void setInactive() = 0;

    virtual void doStart() = 0;
    virtual void doPull() = 0;
    virtual void doCancel() = 0;

private:
    RefPtr<DeferredPromise> m_promise;

    OwnPtr<ReadableStreamDefaultController> m_controller;
};

inline void ReadableStreamSource::start(PassOwnPtr<ReadableStreamDefaultController> controller, RefPtr<DeferredPromise> promise)
{
    ASSERT(!m_promise);
    m_promise = promise;
    m_controller = controller;

    setActive();
    doStart();
}

inline void ReadableStreamSource::pull(RefPtr<DeferredPromise> promise)
{
    ASSERT(!m_promise);
    ASSERT(m_controller);

    m_promise = promise;

    setActive();
    doPull();
}

inline void ReadableStreamSource::startFinished()
{
    ASSERT(m_promise);
    m_promise.release()->resolve(std::nullptr_t());
    setInactive();
}

inline void ReadableStreamSource::pullFinished()
{
    ASSERT(m_promise);
    m_promise.release()->resolve(std::nullptr_t());
    setInactive();
}

inline void ReadableStreamSource::cancel(const ScriptValue&)
{
    clean();
    doCancel();
}

inline void ReadableStreamSource::clean()
{
    if (m_promise) {
    	m_promise.clear();
        setInactive();
    }
}

} // namespace WebCore

#endif // ENABLE(STREAMS_API)

#endif // ReadableStreamSource_h
